
//+------------------------------------------------------------------+
//|                                                Jase Arb Algo.mq4 |
//|                                                  Jason Clarkson  |
//|                                               www.JaseCorp.co.uk |
//+------------------------------------------------------------------+
#property copyright "Jason Clarkson"
#property link      "JaseCorp.co.uk"

//+------------------------------------------------------------------+
//| Algo Start                                                       |
//+------------------------------------------------------------------+
extern double TakeProfit = 100;
extern double Lots = 1;
extern double WinMultiplier = 1.2;
extern double TrailingStop = 30;
extern double TrailingStep = 10;
extern double MACDOpenLevel = 3;
extern double MACDCloseLevel = 2;
extern double MATrendPeriod = 26;
extern double RSIPeriod = 14;
extern int Expert_ID = 1;

int start()
{
bool longArbBool = longArbBool();
bool shortArbBool = shortArbBool();

   dataChecks();
   tradeExec(longArbBool, shortArbBool);
   orderCycle();
}

void dataChecks()
  {   
   if(Bars<100)
     {
      Print ("Bars Less than 100");
      return(0);
     }
   if(TrailingStop<15)
     {
      Print("Trailing Stop less than 15");
      return(0);
     }
  }
bool longArbScan()
  {
   double MacdCurrent, MacdPrevious1, MacdPrevious2; 
   double SignalCurrent, SignalPrevious1, SignalPrevious2;
   double MaCurrent, MaPrevious1, MaPrevious2;
   double RSICurrent, RSIPrevious2, RSIPrevious1;
   int cnt, ticket, total;
   bool longArbBool;
   
   MacdCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MacdPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   SignalCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   SignalPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
   MaCurrent = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious1 = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   MaPrevious2 = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,2);
   RSICurrent = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,0);
   RSIPrevious1 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,1);
   RSIPrevious2 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,2);
   
   if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious1<SignalPrevious1 && MacdPrevious2<SignalPrevious2
   && MathAbs(MacdCurrent)>(MACDOpenLevel*Point) && MaCurrent>((MaPrevious1+MaPrevious2)/2) && RSICurrent<40 && 
   RSICurrent>((RSIPrevious1+RSIPrevious2)/2))
     {
      longArbBool = true;  
     }
   else longArbBool = false;
   return(longArbBool);
  }
    
bool shortArbScan()
  {   
   double MacdCurrent, MacdPrevious1, MacdPrevious2; 
   double SignalCurrent, SignalPrevious1, SignalPrevious2;
   double MaCurrent, MaPrevious1, MaPrevious2;
   double RSICurrent, RSIPrevious2, RSIPrevious1;
   int cnt, ticket, total;
   bool shortArbBool;
   
   MacdCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   MacdPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
   MacdPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
   SignalCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
   SignalPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
   SignalPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
   MaCurrent = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,0);
   MaPrevious1 = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,1);
   MaPrevious2 = iMA(Symbol(),0,MATrendPeriod,0,MODE_EMA,PRICE_CLOSE,2);
   RSICurrent = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,0);
   RSIPrevious1 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,1);
   RSIPrevious2 = iRSI(Symbol(),0,RSIPeriod,PRICE_CLOSE,2);
   
   if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious1>SignalPrevious1 &&
   MacdPrevious2>SignalPrevious2 && MacdCurrent>(MACDOpenLevel*Point) &&
   MaCurrent<((MaPrevious1+MaPrevious2)/2) && RSICurrent>60 && RSICurrent<((RSIPrevious1+RSIPrevious2)/2))
     {
      shortArbBool = true;
     }
   else shortArbBool = false;       
   return(shortArbBool);
  }
  
int tradeExec(longArbBool, shortArbBool)
  {
   double compoundLots;
   int ticket;
   int last_trade=HistoryTotal();
   
   compoundLots = Lots;
   
   if(last_trade>0)
     {
      if(OrderProfit(OrderSelect(last_trade-1,SELECT_BY_POS,MODE_HISTORY))>0)
        {
         compoundLots = compoundLots * WinMultiplier;
        }
     }
   if(longArbBool==true)
     {
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"Jase Buy Order",Expert_ID,0,Green);
      if(ticket>0)
        {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice());
         else Print("Error opening BUY order : ",GetLastError());
        }
     }
   else if(shortArbBool==true)
     {
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"Jase Sell Order",Expert_ID,0,Red);
      if(ticket>0)
        {
         if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened: ", OrderOpenPrice());
         else Print("Error opening SELL order : ",GetLastError());
        }
     }
   return(0);  
  }
    
void orderCycle()
   {
    double MacdCurrent, MacdPrevious1, MacdPrevious2; 
    double SignalCurrent, SignalPrevious1, SignalPrevious2;
    double RSICurrent;
    int cnt, total;
   
    MacdCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
    MacdPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
    MacdPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
    SignalCurrent = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,0);
    SignalPrevious1 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,1);
    SignalPrevious2 = iMACD(Symbol(),0,12,26,9,PRICE_CLOSE,MODE_SIGNAL,2);
    for(cnt=total-1;cnt>=0;cnt--)
       {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if( OrderSymbol() != Symbol()) continue;
        if( OrderMagicNumber() != Expert_ID ) continue;    
          {
           if(OrderType()==OP_BUY)
             {
              if(MacdCurrent>0 && MacdCurrent<SignalCurrent && MacdPrevious1>SignalPrevious1 &&
                 MacdPrevious2>SignalPrevious2 && MacdCurrent>(MACDCloseLevel*Point) && RSICurrent>60)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
                 return(0);
                }
              if(TrailingStop>0 && Ask>=(OrderOpenPrice()+TrailingStop*Point))
                {
                 if((OrderStopLoss()<Bid-(TrailingStop+TrailingStep)*Point) || (OrderStopLoss()== 0))
                   {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Red);
                    return(0);
                   }
                }
             }      
           else    
                { 
                 if(MacdCurrent<0 && MacdCurrent>SignalCurrent && MacdPrevious1<SignalPrevious1 && 
                  MacdPrevious2<SignalPrevious2 && MathAbs(MacdCurrent)>(MACDCloseLevel*Point) && RSICurrent<40)
                   { 
                    OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);//CLOSE SHORT POSITION
                    return(0); //exit
                   }
                 if(TrailingStop>0 && Bid<=(OrderOpenPrice()-TrailingStop*Point))
                   {
                    if((OrderStopLoss()>Bid+(TrailingStop+TrailingStep)*Point)|| (OrderStopLoss() == 0))
                      {
                       OrderModify(OrderTicket(),OrderOpenPrice(),Bid+TrailingStop*Point,OrderTakeProfit(),0,Green);
                       return(0);
                      }
                   }
                }
       }
    return(0);
   }               
}


